diff -uNr linux/mm/bootmem.c linux-2.4.7/mm/bootmem.c
--- linux/mm/bootmem.c	Fri Aug  3 05:39:23 2001
+++ linux-2.4.7/mm/bootmem.c	Wed Apr 17 17:46:33 2002
@@ -94,8 +94,12 @@
 	if (end > bdata->node_low_pfn)
 		BUG();
 	for (i = sidx; i < eidx; i++)
+#if 0
 		if (test_and_set_bit(i, bdata->node_bootmem_map))
 			printk("hm, page %08lx reserved twice.\n", i*PAGE_SIZE);
+#else
+		test_and_set_bit(i, bdata->node_bootmem_map);
+#endif
 }
 
 static void __init free_bootmem_core(bootmem_data_t *bdata, unsigned long addr, unsigned long size)
@@ -148,7 +152,6 @@
 	unsigned long areasize, preferred, incr;
 	unsigned long eidx = bdata->node_low_pfn - (bdata->node_boot_start >>
 							PAGE_SHIFT);
-
 	if (!size) BUG();
 
 	if (align & (align-1))
@@ -244,6 +247,22 @@
 
 	count = 0;
 	idx = bdata->node_low_pfn - (bdata->node_boot_start >> PAGE_SHIFT);
+#if defined(CONFIG_CLPS7110_PSION)
+	{
+		struct page *p;
+
+		printk(KERN_INFO "Freeing pages...(%lx)\n",bdata->node_bootmem_map);
+		for (i = 0; i < idx; i++) {
+			if (!test_bit(i, bdata->node_bootmem_map)) {
+				p = page + __bidx_2_pidx(i);
+				count++;
+				ClearPageReserved(p);
+				set_page_count(p, 1);
+				__free_page(p);
+			}
+		}
+	}
+#else
 	for (i = 0; i < idx; i++, page++) {
 		if (!test_bit(i, bdata->node_bootmem_map)) {
 			count++;
@@ -252,6 +271,7 @@
 			__free_page(page);
 		}
 	}
+#endif
 	total += count;
 
 	/*
diff -uNr linux/mm/page_alloc.c linux-2.4.7/mm/page_alloc.c
--- linux/mm/page_alloc.c	Fri Aug  3 05:39:23 2001
+++ linux-2.4.7/mm/page_alloc.c	Wed Apr 17 17:47:15 2002
@@ -21,7 +21,7 @@
 int nr_swap_pages;
 int nr_active_pages;
 int nr_inactive_dirty_pages;
-pg_data_t *pgdat_list;
+pg_data_t *pgdat_list = 0;
 
 static char *zone_names[MAX_NR_ZONES] = { "DMA", "Normal", "HighMem" };
 static int zone_balance_ratio[MAX_NR_ZONES] = { 32, 128, 128, };
@@ -53,7 +53,8 @@
 /*
  * Temporary debugging check.
  */
-#define BAD_RANGE(zone,x) (((zone) != (x)->zone) || (((x)-mem_map) < (zone)->zone_start_mapnr) || (((x)-mem_map) >= (zone)->zone_start_mapnr+(zone)->size))
+//#define BAD_RANGE(zone,x) (((zone) != (x)->zone) || (((x)-mem_map) < (zone)->zone_start_mapnr) || (((x)-mem_map) >= (zone)->zone_start_mapnr+(zone)->size))
+#define BAD_RANGE(zone,x) ((zone) != (x)->zone)
 
 /*
  * Buddy system. Hairy. You really aren't expected to understand this
@@ -165,7 +166,9 @@
 		page += size;
 	}
 	if (BAD_RANGE(zone,page))
+	{
 		BUG();
+	}
 	return page;
 }
 
@@ -760,7 +763,7 @@
 	if (zholes_size)
 		for (i = 0; i < MAX_NR_ZONES; i++)
 			realtotalpages -= zholes_size[i];
-			
+
 	printk("On node %d totalpages: %lu\n", nid, realtotalpages);
 
 	memlist_init(&active_list);
@@ -782,7 +785,8 @@
 	*gmap = pgdat->node_mem_map = lmem_map;
 	pgdat->node_size = totalpages;
 	pgdat->node_start_paddr = zone_start_paddr;
-	pgdat->node_start_mapnr = (lmem_map - mem_map);
+//	pgdat->node_start_mapnr = (lmem_map - mem_map);
+	pgdat->node_start_mapnr = (lmem_map - NODE_MEM_MAP(nid));
 
 	/*
 	 * Initially all pages are reserved - free ones are freed
@@ -796,7 +800,8 @@
 		memlist_init(&p->list);
 	}
 
-	offset = lmem_map - mem_map;	
+//	offset = lmem_map - mem_map;	
+	offset = lmem_map - NODE_MEM_MAP(nid);	
 	for (j = 0; j < MAX_NR_ZONES; j++) {
 		zone_t *zone = pgdat->node_zones + j;
 		unsigned long mask;
@@ -840,7 +845,8 @@
 		freepages.min += mask;
 		freepages.low += mask*2;
 		freepages.high += mask*3;
-		zone->zone_mem_map = mem_map + offset;
+//		zone->zone_mem_map = mem_map + offset;
+		zone->zone_mem_map = NODE_MEM_MAP(nid) + offset;
 		zone->zone_start_mapnr = offset;
 		zone->zone_start_paddr = zone_start_paddr;
 
@@ -848,10 +854,15 @@
 			printk("BUG: wrong zone alignment, it will crash\n");
 
 		for (i = 0; i < size; i++) {
-			struct page *page = mem_map + offset + i;
+//			struct page *page = mem_map + offset + i;
+			struct page *page = NODE_MEM_MAP(nid) + offset + i;
 			page->zone = zone;
 			if (j != ZONE_HIGHMEM)
+#if defined(CONFIG_CLPS7110_PSION)
+				page->virtual = (void *)zone_start_paddr;
+#else
 				page->virtual = __va(zone_start_paddr);
+#endif
 			zone_start_paddr += PAGE_SIZE;
 		}
 
